#include <climits>
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
using namespace std ;
int match(const vector<int> &pv, const vector<int> &qv, int S, int d) {
   int qi = 0 ;
   int r = 0 ;
   vector<int> stack ;
   for (auto p: pv) {
      int lo = p - d ;
      int hi = min(p+d, S-p) ;
      if (hi < lo) // no possible match
         continue ;

      // first we get all elements of Q that are <= hi and put
      // them on our stack of candidates.  Stack is always sorted.
      // This only adds elements as hi increases, and enforces S.

      while (qi < (int)qv.size() && qv[qi] <= hi) {
         stack.push_back(qv[qi]) ;
         qi++ ;
      }

      // now we kill any stack elements that are already on the
      // stack but too high (due to D).  This will only happen
      // as hi goes down due to D.

      while (stack.size() > 0 && stack[stack.size()-1] > hi)
         stack.pop_back() ;

      // at this point every element on the stack (if any) satisfies
      // hi.  If the largest element (the last one) also satisfies lo,
      // we snarf it---we have a match!

      if (stack.size() > 0 && stack[stack.size()-1] >= lo) {
         stack.pop_back() ;
         r++ ;
      }
   }
   return r ;
}
int main() {
   int M, P, Q, S ;
   cin >> M >> P >> Q >> S ;
   vector<int> pv(P), qv(Q) ;
   for (auto &v : pv)
      cin >> v ;
   for (auto &v : qv)
      cin >> v ;
   sort(pv.begin(), pv.end()) ;
   sort(qv.begin(), qv.end()) ;
   reverse(pv.begin(), pv.end()) ;
   int lo = 0x7fffffff ;
   for (int b = 32768 * 32768; b; b>>=1)
      if (match(pv, qv, S, lo-b) >= M)
         lo -= b ;
   cout << (lo == 0x7fffffff ? -1 : lo) << endl ;
}
