import java.io.*;
import java.util.*;

public class ICPCCamp_Arknave {
    static int INF = 1000000007;
    public static void main(String[] args) throws IOException {
        // If we use Scanner we will be about 1 second slower.
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] tokens = br.readLine().split(" ");
        int n = Integer.parseInt(tokens[0]);
        int p = Integer.parseInt(tokens[1]);
        int q = Integer.parseInt(tokens[2]);
        int s = Integer.parseInt(tokens[3]);

        int[] a = new int[p];
        for (int i = 0; i < p; i++) {
            a[i] = Integer.parseInt(br.readLine());
        }

        int[] b = new int[q];
        for (int i = 0; i < q; i++) {
            b[i] = Integer.parseInt(br.readLine());
        }

        Arrays.sort(a);
        // reverse the array
        for (int i = 0, j = p - 1; i < j; i++, j--) {
            int t = a[i];
            a[i] = a[j];
            a[j] = t;
        }

        TreeMap<Integer, Integer> base = new TreeMap<>();
        for (int x : b) {
            base.put(x, base.getOrDefault(x, 0) + 1);
        }

        int lo = -1;
        int hi = INF;
        while (lo + 1 < hi) {
            int mid = (lo + hi) / 2;
            TreeMap<Integer, Integer> tm = new TreeMap<>(base);
            int hits = 0;
            for (int x : a) {
                if (hits >= n) break;

                Integer y = tm.floorKey(Math.min(s - x, x + mid));
                if (y != null && y >= x - mid) {
                    ++hits;
                    int newFreq = tm.get(y) - 1;
                    if (newFreq == 0) {
                        tm.remove(y);
                    } else {
                        tm.put(y, newFreq);
                    }
                }
            }

            if (hits >= n) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        if (hi == INF)
            hi = -1;

        System.out.println(hi);
    }
}
