#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <utility>
#include <tuple>

using namespace std;

using ll = long long;

int solve(const vector<vector<ll>>& a, ll d, ll s) {
    multiset<ll> m(begin(a[1]), end(a[1]));
    int hits = 0;
    for (ll x : a[0]) {
        auto it = m.upper_bound(min(s - x, x + d));
        if (it != begin(m) and *prev(it) >= x - d) {
            ++hits;
            m.erase(prev(it));
        }
    }

    return hits;
}

int main() {
    int n, p, q;
    ll s;
    cin >> n >> p >> q >> s;

    vector<vector<ll>> a(2);
    a[0].resize(p);
    a[1].resize(q);
    for (int k = 0; k < 2; ++k) {
        for (auto& x : a[k])
            cin >> x;
        sort(begin(a[k]), end(a[k]));
    }

    reverse(begin(a[0]), end(a[0]));
    ll lo = -1;
    ll hi = 1e10 + 7;
    while (lo + 1 < hi) {
        ll mid = (lo + hi) / 2;
        if (solve(a, mid, s) >= n) {
            hi = mid;
        } else {
            lo = mid;
        }
    }

    if (solve(a, hi, s) < n) {
        cout << -1 << '\n';
    } else {
        cout << hi << '\n';
    }

    return 0;
}
