#include <climits>
#include <iostream>
#include <map>
#include <vector>
#include <string>
using namespace std ;
struct e {
   int v, flow, c, rev ;
} ;
struct g {
   int v ;
   vector<vector<e>> adj ;
   vector<int> level ;
   g(int v_) : v(v_), adj(v_), level(v_) {}
   void addedge(int a, int b, int c) {
      e ab {b,0,c,(int)adj[b].size()} ;
      e ba {a,0,0,(int)adj[a].size()} ;
      adj[a].push_back(ab) ;
      adj[b].push_back(ba) ;
   }
   int bfs(int s, int t);
   int sendflow(int s, int flow, int t, vector<int> &ptr) ;
   int dinic(int s, int t) ;
} ;
int g::bfs(int s, int t) {
   for (auto &v : level)
      v = -1 ;
   level[s] = 0 ;
   vector<int> q ;
   q.push_back(s) ;
   for (int qg=0; qg<(int)q.size(); qg++) {
      int a = q[qg] ;
      for (auto &e:adj[a])
         if (level[e.v] < 0 && e.flow < e.c) {
            level[e.v] = level[a]+1 ;
            q.push_back(e.v) ;
         }
   } 
   return level[t] >= 0 ;
}
int g::sendflow(int a, int flow, int t, vector<int> &start) {
   if (a == t) 
      return flow ;
   for (; start[a]<(int)adj[a].size(); start[a]++) {
      e &e = adj[a][start[a]] ;
      if (level[e.v] == level[a]+1 && e.flow < e.c) {
         int curf = min(flow, e.c-e.flow) ;
         int tempf = sendflow(e.v, curf, t, start) ;
         if (tempf > 0) {
            e.flow += tempf ;
            adj[e.v][e.rev].flow -= tempf ;
            return tempf ;
         }
      }
   }
   return 0 ;
}
int g::dinic(int s, int t) {
   if (s == t)
      return -1 ;
   int tot = 0 ;
   vector<int> start(v+1) ;
   while (bfs(s, t)) {
      for (auto &v : start)
         v = 0 ;
      while (int f=sendflow(s, INT_MAX, t, start))
         tot += f ;
   }
   return tot ;
}
int main() {
   int M, P, Q, S ;
   cin >> M >> P >> Q >> S ;
   vector<int> pv(P), qv(Q) ;
   for (auto &v : pv)
      cin >> v ;
   for (auto &v : qv)
      cin >> v ;
   int lo = 0x7fffffff ;
   for (int b = 32768 * 32768; b; b>>=1) {
      g graph(P+Q+2) ;
      for (int pi=0; pi<(int)pv.size(); pi++) {
         graph.addedge(P+Q, pi, 1) ;
         for (int qi=0; qi<(int)qv.size(); qi++)
            if (pv[pi]+qv[qi] <= S && abs(pv[pi]-qv[qi]) <= (lo-b)) {
               graph.addedge(pi, P+qi, 1) ;
            }
      }
      for (int qi=0; qi<(int)qv.size(); qi++)
         graph.addedge(P+qi, P+Q+1, 1) ;
      int m = graph.dinic(P+Q, P+Q+1) ;
      if (m >= M)
         lo -= b ;
   }
   cout << (lo == 0x7fffffff ? -1 : lo) << endl ;
}
