// Same as vector.cpp. But swap list P vs list Q.

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 100005

int n, p, q;
VI A, B;
bool solve(int D, int S) {
  int ans = 0;
  for (int i = p - 1; i >= 0; i--) {
		int upbound = min(S - A[i], A[i] + D);
		auto jt = upper_bound(B.begin(), B.end(), upbound);
		if (jt == B.begin()) continue;
		jt--;
		if (*jt < A[i] - D) continue;
		if (++ans >= n) return true;
		B.erase(jt);
	}
  return false;
}

int main() {
	int S, v;
  cin >> n >> p >> q >> S;
  REP(i,0,p) {
    cin >> v;
    A.push_back(v);
  }
  REP(i,0,q) {
    cin >> v;
    B.push_back(v);
  }
	sort(A.begin(), A.end());
	sort(B.begin(), B.end());
	swap(A, B);
	swap(p, q);

  VI Bo = B;
  int l = 0, r = INF;
  while (l <= r) {
    B = Bo;
    int m = (l + r) / 2;
    if (solve(m, S)) r = m - 1;
    else l = m + 1;
  }
	cout << (l >= INF ? -1 : l) << endl;
	return 0;
}
