// Applies wrong greedy and matches the largest from P with the smallest from Q.
// This is O(n^2) and should be caught by small-sized greedy breaker cases.

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 200005

int n, p, q, a[MAXN], b[MAXN];
bool v[MAXN];
bool solve(int D, int S) {
  FILL(v ,0);
  int ans = 0;
  for (int i = p - 1; i >= 0; i--) {
    REP(j,0,q) {
      if (a[i] + b[j] > S) break;
      if (abs(a[i] - b[j]) <= D && !v[j]) {
        v[j] = 1;
        if (++ans >= n) return true;
        break;
      }
      if (b[j] > a[i] + D) break;
    }
  }
  return false;
}
int main() {
  int S;
  cin >> n >> p >> q >> S;
  REP(i,0,p) cin >> a[i];
  REP(i,0,q) cin >> b[i];
  sort(a, a + p);
  sort(b, b + q);
  int l = 0, r = INF;
  while (l <= r) {
    int m = (l + r) / 2;
    if (solve(m, S)) r = m - 1;
    else l = m + 1;
  }
  cout << (l >= INF ? -1 : l) << endl;
  return 0;
}
